package org.adee.samples.stringTokenizer;

public class SplitExample {

	public static void splitWithLimit() {
		String source = "705-103-102-456-123 : 112 _343-1 789----";
		System.out.println(" Source String is " + source + " | Regex is - ");
		// split with - and return 3 entries in array
		for (String x : source.split("-", 4)) {
			System.out.println("splitWithLimit (limit = 4) : Split Item -> " + x);
		}
		System.out.println(" ---------------------------------------------------------------- ");
		// split with - and return all splits including trailing empty strings
		for (String x : source.split("-", -3)) {
			System.out.println("splitWithLimit (limit = -3): Split Item -> " + x);
		}
		System.out.println(" ---------------------------------------------------------------- ");
		// split with - and return all splits discard the trailing empty strings
		for (String x : source.split("-", 0)) {
			System.out.println("splitWithLimit (limit = -3): Split Item -> " + x);
		}
		System.out.println(" ---------------------------------------------------------------- ");
	}

	public static void splitPolynomial() {
		String expr = "10*a^2 + 1/3*b - c^2";
		System.out.println(" Source String is " + expr);
		// delimiters are: + * / ^ space -
		String regex = "[+*/^ \\-]+";
		System.out.println(" Splitting with Regex - " + regex);
		for (String str : expr.split(regex)) {
			System.out.println("splitPolynomial - " + str);
		}
	}

	public static void splitEmail() {
		String sourceString = "poohpool@signet.co,swd@websource.co.in, jobs@websource.co.in, info@rupizxpress.com, mla@mla-india.com";
		System.out.println(" Source String is " + sourceString);
		for (String email : sourceString.split(",")) {
			for (String details : email.split("@")) {
				System.out.println("Details are  " + details);
			}
			System.out.println(" --------- NEXT - RECORD -------- ");
		}
	}

	public static void main(String[] args) {
		splitWithLimit();
		splitPolynomial();
		splitEmail();
	}
}
