package org.adee.samples.stringTokenizer;

import java.util.StringTokenizer;

public class StringTokenizerSample {

	public static void testNoDelimiters() {
		String sourceString = "This is a\nsample of\nnew big line-with\ttabs and\rcarriage-returns";
		System.out.println("Source String is " + sourceString);
		// uses default set of characters as delimiters
		StringTokenizer st = new StringTokenizer(sourceString);
		while (st.hasMoreTokens()) {
			System.out.println("testNoDelimiters : Next-Token = " + st.nextToken());
		}
		System.out.println(" ------------------------------------------------------------------------------ ");
		// user space character as a delimiter; this
		// will disregard the default delimiter character set
		st = new StringTokenizer(sourceString, " ");
		while (st.hasMoreTokens()) {
			System.out.println("testSpaceDelimiter : Next-Token = " + st.nextToken());
		}
		System.out.println(" ------------------------------------------------------------------------------ ");
	}

	public static void testDelimiterColon() {
		String sourceString = "Computer Science:Programming:Java:String Tokenizer:Example";
		StringTokenizer st = new StringTokenizer(sourceString, ":");
		System.out.println("Source String is " + sourceString + "| Delimiter is : ");
		System.out.println("testCountTokens : " + st.countTokens());
		while (st.hasMoreTokens()) {
			System.out.println("testDelimiterColon : Next-Token = " + st.nextToken());
		}
		System.out.println(" ------------------------------------------------------------------------------ ");
		st = new StringTokenizer(sourceString, ":", true);
		System.out.println("testReturnDelimiters : Count-Tokens " + st.countTokens());
		while (st.hasMoreTokens()) {
			System.out.println("testReturnDelimiters : Next-Token = " + st.nextToken());
		}
		System.out.println(" ------------------------------------------------------------------------------ ");
	}

	public static void testNextTokenWithDelim() {
		String sourceString = "This-String_Example-has space , hyphen-and_hyphen-and_underscores";
		StringTokenizer st = new StringTokenizer(sourceString);
		System.out.println("Source String is " + sourceString);
		if (st.hasMoreTokens()) {
			// nextToken with delimiter _
			System.out.println("testNextTokenWithDelim | Delimiter _ : Next-Token = " + st.nextToken("_"));
		}
		while (st.hasMoreTokens()) {
			// nextToken with delimiter -
			System.out.println("testNextTokenWithDelim | Delimiter - : Next-Token = " + st.nextToken("-"));
		}
		System.out.println(" ------------------------------------------------------------------------------ ");
	}

	public static void testLongStringDelimiter() {
		String sourceString = "Anmol_Deep_Java_Code_Geeks_Java_Author";
		System.out.println("Source String is " + sourceString +  " | Delimiter is _Java");
		StringTokenizer st = new StringTokenizer(sourceString, "_Java");
		System.out.println("testLongStringDelimiter : Count-Tokens " + st.countTokens());
		while (st.hasMoreTokens()) {
			System.out.println("testLongStringDelimiter : Next-Token = " + st.nextToken());
		}
		System.out.println(" ------------------------------------------------------------------------------ ");
	}

	public static void main(String[] args) {
		testNoDelimiters();
		testDelimiterColon();
		testNextTokenWithDelim();
		testLongStringDelimiter();
	}
}